local L = WT_Locale;
local faction = UnitFactionGroup("player");
local follower_state = "active";
local frame_table = {};
frame_table.buttons = {};
wt_state = true;

-- Loaded Frame
local loaded_frame = CreateFrame("Frame");
loaded_frame:RegisterEvent("ADDON_LOADED");
function loaded_frame:OnEvent(event, addon)
	if addon == "Watchtower" then
		Start_Event_Handler();
	end
end
loaded_frame:SetScript("OnEvent", loaded_frame.OnEvent);
-- End Loaded Frame

-- Start Event_Handler
function Start_Event_Handler()

	local event_frame = CreateFrame("Frame");
	event_frame:RegisterEvent("GARRISON_MISSION_NPC_OPENED");
	event_frame:RegisterEvent("GARRISON_MISSION_NPC_CLOSED");
	event_frame:RegisterEvent("GARRISON_FOLLOWER_LIST_UPDATE");
	--event_frame:RegisterAllEvents();
	event_frame:SetScript("OnEvent", function(self, event)
		--print(event);
		if event == "GARRISON_MISSION_NPC_OPENED" then
			--if wt_state == true then
				Create_Watchtower_Frames();
				follower_sync();
			--end
		elseif event == "GARRISON_MISSION_NPC_CLOSED" then
			
		elseif event == "GARRISON_FOLLOWER_LIST_UPDATE" then
			if GarrisonMissionFrame.selectedTab == 2 then
				--if wt_state == true then
					follower_sync();
				--end
			end
		end
	end)
	
end
-- End Event_Handler


-- Create all Watchtower Frames
function Create_Watchtower_Frames()
	
	if toggle_button == nil then
		local toggle = CreateFrame("Button", "toggle_button", GarrisonMissionFrame, "UIPanelButtonTemplate");
		toggle:SetSize(100, 20);
		toggle:SetPoint("TOPRIGHT", GarrisonMissionFrame, "TOPRIGHT", -25, 0);
		toggle:SetText("Watchtower");
		toggle:SetScript("OnClick", function(self)
			if wt_state == true then
				wt_state = false;
				Create_Watchtower_Frames();
			else
				wt_state = true;
				Create_Watchtower_Frames();
			end
			--print(wt_state);
		end)
	end
	
	
	
	
	if WT_Graph == nil then
		
		local containers = WatchtowerDB.containers;
		local backdrop = {bgFile = "Interface\\DialogFrame\\UI-DialogBox-Background", tile = true, tileSize = 32};
		local x_size, y_size = GarrisonMissionFrame:GetSize();
		
		GarrisonMissionFrame:SetPoint("CENTER", UIParent, "CENTER", -200, 0 );
		MakeMovable(GarrisonMissionFrame);
		
		local graph = CreateFrame("Frame", "WT_Graph", GarrisonMissionFrame, "GarrisonUITemplate");
		graph:SetSize(420, y_size);
		graph:SetPoint("LEFT", GarrisonMissionFrame, "RIGHT", 1, 0);
		graph:EnableMouse(true);
		graph.CloseButton:Hide();
		graph:CreateFontString("Title","ARTWORK" ,"GameFontNormal");
		Title:SetText(L["Watchtower"]);
		Title:SetPoint("TOP", 0, -5);
		graph:CreateFontString("Footer", "ARTWORK", "GameFontNormalSmall");
		Footer:SetText("Lot20Syndicate");
		Footer:SetPoint("BOTTOMRIGHT", -50, 5);
		
		local greybox = CreateFrame("Frame", "WT_greybox", graph, "GarrisonMissionBaseFrameTemplate")
		greybox:SetSize(330, (y_size - 80));
		greybox:SetPoint("CENTER", graph, "CENTER", -10, -5);
		greybox:CreateTexture("WT_Icon_overlay", "ARTWORK");
		WT_Icon_overlay:SetPoint("TOPRIGHT", graph, "TOPRIGHT", 65, 30);
		WT_Icon_overlay:SetTexture("Interface\\ExtraButton\\ChampionLight.blp");
		WT_Icon_overlay:SetSize(160,80);
		greybox:CreateTexture("WT_Icon", "ARTWORK", nil, -1);
		WT_Icon:SetPoint("CENTER", WT_Icon_overlay, "CENTER", 1, 0);
		WT_Icon:SetTexture("Interface\\ICONS\\TEMP.blp");
		WT_Icon:SetSize(32,32);
		
		local scrollframe = CreateFrame("ScrollFrame", nil, greybox)
		scrollframe:SetPoint("TOPLEFT", 10, -10)
		scrollframe:SetPoint("BOTTOMRIGHT", -10, 15)
		greybox.scrollframe = scrollframe
		
		scrollframe:EnableMouseWheel(true);
		scrollframe:SetScript("OnMouseWheel", function(self, delta)
			local bar_value = greybox.scrollbar:GetValue();
			greybox.scrollbar:SetValue(bar_value - (delta * 45));
		end)
		
		local scrollbar = CreateFrame("Slider", nil, scrollframe, "UIPanelScrollBarTemplate")
		scrollbar:SetPoint("TOPLEFT", greybox, "TOPRIGHT", 4, -16)
		scrollbar:SetPoint("BOTTOMLEFT", greybox, "BOTTOMRIGHT", 4, 16)
		scrollbar:SetMinMaxValues(1, 530)
		scrollbar:SetValueStep(1)
		scrollbar.scrollStep = 1
		scrollbar:SetValue(0)
		scrollbar:SetWidth(16)
		scrollbar:SetScript("OnValueChanged",
		function (self, value)
		self:GetParent():SetVerticalScroll(value)
		end)
		local scrollbg = scrollbar:CreateTexture(nil, "BACKGROUND")
		scrollbg:SetAllPoints(scrollbar)
		scrollbg:SetTexture(0, 0, 0, .8)
		greybox.scrollbar = scrollbar
		
		local content = CreateFrame("Frame", "WT_Content", scrollframe)
		content:SetSize(300, 530)
		scrollframe.content = content
		scrollframe:SetScrollChild(content) 
		
		local active_tab = CreateFrame("Button", "WatchtowerTab1", graph, "GarrisonMissionFrameTabTemplate")
		active_tab:SetPoint("TOPLEFT", graph , "BOTTOMLEFT", 15, 0);
		PanelTemplates_DeselectTab(active_tab);
		active_tab:SetText(L["Active"]);
		PanelTemplates_TabResize(active_tab, 10);
		PanelTemplates_SelectTab(active_tab);
		
		local inactive_tab = CreateFrame("Button", "WatchtowerTab2", graph, "GarrisonMissionFrameTabTemplate")
		inactive_tab:SetPoint("LEFT", active_tab , "RIGHT", -10, 0);
		PanelTemplates_DeselectTab(inactive_tab);
		inactive_tab:SetText(L["Inactive"]);
		PanelTemplates_TabResize(inactive_tab, 10);
		
		
		inactive_tab:SetScript("OnClick", function()	
			PanelTemplates_SelectTab(inactive_tab);
			PanelTemplates_DeselectTab(active_tab);
			follower_state = "inactive";
			follower_sync();
			
		end);
		
		active_tab:SetScript("OnClick", function()	
			PanelTemplates_SelectTab(active_tab);
			PanelTemplates_DeselectTab(inactive_tab);
			follower_state = "active";
			follower_sync();
			
		end);
		for i = 1, #containers do
			local box = CreateFrame("Frame", containers[i].name, content);
			box:SetBackdrop(backdrop);
			box:SetSize(containers[i].x, containers[i].y);
			box:SetPoint(containers[i].self_anchor, containers[i].relativeto, containers[i].parent_anchor, containers[i].x_offset, containers[i].y_offset);
			local title = box:CreateFontString(nil, "ARTWORK", "QuestFontNormalSmall");
			title:SetText("|cffffff00" .. L[containers[i].title] .. "|r");
			title:SetPoint("TOP", 0, -5);
			for index2 = 0,9 do
				local line = box:CreateTexture(nil);
				line:SetTexture(1.0, 1.0, 1.0, 0.1);
				line:SetSize((containers[i].x - 50),1);
				line:SetPoint("BOTTOM", 0, ((index2 * 10) + 30));
				local numleft = box:CreateFontString(nil,"ARTWORK" ,"GameFontNormalSmall");
				local numright = box:CreateFontString(nil,"ARTWORK" ,"GameFontNormalSmall");
				numleft:SetPoint("LEFT", line, "RIGHT", 5, 0);
				numright:SetPoint("RIGHT", line, "LEFT",-5, 0);
				if index2 < 0 then
					numleft:SetText(index2 * (-1));
					numright:SetText(index2 * (-1));
				else
					numleft:SetText(index2);
					numright:SetText(index2);
				end
			end
		end
		create_trait_buttons(WatchtowerDB.counters, WT_Counters);
		create_trait_buttons(WatchtowerDB.specials, WT_Duration);
		create_trait_buttons(WatchtowerDB.experience, WT_Experience);
		create_trait_buttons(WatchtowerDB.slayer, WT_Slayer);
		create_trait_buttons(WatchtowerDB.terrain, WT_Terrain);
		create_trait_buttons(WatchtowerDB.profession, WT_Profession);
		if faction == "Alliance" then
			create_trait_buttons(WatchtowerDB.groupa, WT_Group);
		else
			create_trait_buttons(WatchtowerDB.grouph, WT_Group);
		end
	end
	
	if wt_state == true then
		WT_Graph:Show();
	else
		WT_Graph:Hide();
	end
	
end
-- End Watchtower Frame Creation

function follower_sync()

	local all_followers = C_Garrison.GetFollowers();
	local my_followers = {};
	
	for i = 1, #all_followers do
		if all_followers[i].isCollected then
			table.insert(my_followers, all_followers[i]);
		end
	end
	
	follower_parse(WatchtowerDB.counters, my_followers);
	follower_parse(WatchtowerDB.specials, my_followers);
	follower_parse(WatchtowerDB.experience, my_followers);
	follower_parse(WatchtowerDB.groupa, my_followers);
	follower_parse(WatchtowerDB.grouph, my_followers);
	follower_parse(WatchtowerDB.slayer, my_followers);
	follower_parse(WatchtowerDB.terrain, my_followers);
	follower_parse(WatchtowerDB.profession, my_followers);
	
	pop_tooltips(WatchtowerDB.counters);
	pop_tooltips(WatchtowerDB.specials);
	pop_tooltips(WatchtowerDB.experience);
	pop_tooltips(WatchtowerDB.slayer);
	pop_tooltips(WatchtowerDB.terrain);
	pop_tooltips(WatchtowerDB.profession);
	if faction == "Alliance" then
		pop_tooltips(WatchtowerDB.groupa);
	else
		pop_tooltips(WatchtowerDB.grouph);
	end
	
	
	
end

function pop_tooltips(traits)

	for i =1, #traits do
	
		if follower_state == "active" then
				
				frame_table[traits[i].name .. "_over"]:Hide();
				frame_table[traits[i].texture_name_inactive]:SetTexture(0.8,0.0,0.0,0.0);
				frame_table[traits[i].texture_name_active]:SetTexture(0.0,0.8,0.0,0.3);
				if the_count(traits[i].active) < 1 then
					frame_table[traits[i].texture_name_active]:SetTexture(0.0,0.8,0.0,0.0);
				elseif the_count(traits[i].active) > 9 then
					frame_table[traits[i].texture_name_active]:SetSize(18, 90);
					frame_table[traits[i].name .. "_over"]:Show();
				else
					frame_table[traits[i].texture_name_active]:SetSize(18, the_count(traits[i].active) *10);
				end
			
		elseif follower_state == "inactive" then
				
				frame_table[traits[i].name .. "_over"]:Hide();
				frame_table[traits[i].texture_name_active]:SetTexture(0.8,0.0,0.0,0.0);
				frame_table[traits[i].texture_name_inactive]:SetTexture(0.8,0.0,0.0,0.3);
				if the_count(traits[i].inactive) < 1 then
					frame_table[traits[i].texture_name_inactive]:SetTexture(0.8,0.0,0.0,0.0);
				elseif the_count(traits[i].inactive) > 9 then
					frame_table[traits[i].texture_name_inactive]:SetSize(18, 90);
				else
					frame_table[traits[i].texture_name_inactive]:SetSize(18, the_count(traits[i].inactive) *10);
				end
			
		end
	
		frame_table.buttons[traits[i].button_name]:SetScript("OnEnter", function(self, motion)
			GameTooltip:SetOwner(self, "ANCHOR_RIGHT");
			if follower_state == "active" then
				GameTooltip:SetText(traits[i].name .. "  " .. "("  .. the_count(traits[i].active) .. ")");
			else
				GameTooltip:SetText(traits[i].name .. "  " .. "("  .. the_count(traits[i].inactive) .. ")");
			end
			new_active = {};
			new_inactive = {};
			if follower_state == "active" then
				for key,value in pairs(traits[i].active) do
					table.insert(new_active, value);
				end
				table.sort(new_active, follower_sorting);
				if #new_active ~= 0 then
					GameTooltip:AddDoubleLine(" ", " ");
				end
				tipsy(new_active);
			else
				for key,value in pairs(traits[i].inactive) do
					table.insert(new_inactive, value);
				end
				table.sort(new_inactive, follower_sorting);
				if #new_inactive ~= 0 then
					GameTooltip:AddDoubleLine(" ", " ");
				end
				tipsy(new_inactive);
			end
			GameTooltip:Show();
		end)
		frame_table.buttons[traits[i].button_name]:SetScript("OnLeave", function(self, motion)
			GameTooltip:Hide();
		end);	
	end	
end


function create_trait_buttons(trait, data_frame)
	
	for index = 1, #trait do
		
		frame_table.buttons[trait[index].button_name] = CreateFrame("Button", "WT_" .. trait[index].name, data_frame);
		frame_table.buttons[trait[index].button_name]:SetNormalTexture(trait[index].icon);
		frame_table.buttons[trait[index].button_name]:SetSize(18,18);
		frame_table.buttons[trait[index].button_name]:SetPoint(trait[index].self_anchor, trait[index].relativeto, trait[index].parent_anchor, trait[index].x_offset, trait[index].y_offset);
		
		frame_table.buttons[trait[index].button_name]:SetScript("OnClick", function()
			GarrisonMissionFrameTab2:Click();
			GarrisonMissionFrameFollowers.SearchBox:SetText(trait[index].name);
		end)
		
		
		frame_table[trait[index].texture_name_active]  = frame_table.buttons[trait[index].button_name]:CreateTexture("WT_" .. trait[index].name .. "_active");
		frame_table[trait[index].texture_name_active]:SetTexture(0.0,0.8,0.0,0.3);
		frame_table[trait[index].texture_name_active]:SetSize(18,90);
		frame_table[trait[index].texture_name_active]:SetPoint("BOTTOM", "WT_" .. trait[index].name, "TOP", 0, 7.5);
		
		frame_table[trait[index].texture_name_inactive] = frame_table.buttons[trait[index].button_name]:CreateTexture("WT_" .. trait[index].name .. "_inactive");
		frame_table[trait[index].texture_name_inactive]:SetTexture(0.8,0.0,0.0,0.3);
		frame_table[trait[index].texture_name_inactive]:SetSize(18,90);
		frame_table[trait[index].texture_name_inactive]:SetPoint("BOTTOM", "WT_" .. trait[index].name, "TOP", 0, 7.5);
		
		frame_table[trait[index].name .. "_over"] = CreateFrame("Button", "WT_" .. trait[index].name .. "_over", data_frame);
		frame_table[trait[index].name .. "_over"]:SetNormalTexture("Interface\\PETBATTLES\\BattleBar-AbilityBadge-Strong.blp");
		frame_table[trait[index].name .. "_over"]:SetSize(15,15);
		frame_table[trait[index].name .. "_over"]:SetPoint("BOTTOM", frame_table[trait[index].texture_name_active], "TOP", 0, -1);
		
		
	end
		
end


function follower_parse(traitList, my_followers)

	for key, trait in pairs(traitList) do
	
		for k in pairs (trait.active) do
			trait.active[k] = nil
		end -- for
		
		for k in pairs (trait.inactive) do
			trait.inactive[k] = nil
		end -- for
		
		
		for follower = 1, #my_followers do
			local status = my_followers[follower].status;
			follower_abilities = C_Garrison.GetFollowerAbilities(my_followers[follower].followerID);
			for abilities = 1, #follower_abilities do
				ability = follower_abilities[abilities];
				if ability.isTrait then
					if ability.name == trait.name then
						if status == "Inactive" then
							trait.inactive[my_followers[follower].name] = my_followers[follower];
						else
							trait.active[my_followers[follower].name] = my_followers[follower];
						end
					end
				else
					for key, value in pairs(ability.counters) do
						if value.name == trait.name then
							if status == "Inactive" then
								trait.inactive[my_followers[follower].name] = my_followers[follower];
							else
								trait.active[my_followers[follower].name] = my_followers[follower];
							end
						end
					end
				end
			end
		end
	end

end

-- make frames movable
function MakeMovable(frame)

	frame:SetMovable(true)
	frame:RegisterForDrag("LeftButton")
	frame:SetScript("OnDragStart", frame.StartMoving)
	frame:SetScript("OnDragStop", frame.StopMovingOrSizing)
	frame:SetClampedToScreen(true);
	
end

function the_count(arg)
	counter = 0;
	for key in pairs(arg) do
		counter = counter +1;
	end
	return counter;
end

function tipsy(tbl)
	for key, value in ipairs(tbl) do
		local status = "";
		if value.status == "Inactive" then
			status = "|cffffffff[|r" .. "|cffff0000Inactive|r" .. "|cffffffff]|r";
		else
			if value.status == nil then
				status = "|cffffffff[|r" .. "|cff1eff00Idle|r"  .. "|cffffffff]|r";
			else
				status = "|cffffffff[|r" .. "|cff1eff00" .. value.status .. "|r"  .. "|cffffffff]|r";
			end
		end
				
		if value.quality == 5 then
			if value.level < 100 then
				GameTooltip:AddDoubleLine("|cffff8000[" .. value.level .. "] |r" .. "|cffffffff" .. value.name .. "|r", status);
			else
				GameTooltip:AddDoubleLine("|cffff8000[" .. value.iLevel .. "] |r" .. "|cffffffff" .. value.name .. "|r", status); 
			end	
		elseif value.quality == 4 then
			if value.level < 100 then
				GameTooltip:AddDoubleLine("|cffa335ee[" .. value.level .. "] |r" .. "|cffffffff" .. value.name .. "|r", status);
			else
				GameTooltip:AddDoubleLine("|cffa335ee[" .. value.iLevel .. "] |r" .. "|cffffffff" .. value.name .. "|r", status);
			end
		elseif value.quality == 3 then
			if value.level < 100 then
				GameTooltip:AddDoubleLine("|cff0070dd[" .. value.level .. "] |r" .. "|cffffffff" .. value.name .. "|r", status);
			else
				GameTooltip:AddDoubleLine("|cff0070dd[" .. value.iLevel .. "] |r" .. "|cffffffff" .. value.name .. "|r", status);
			end
		elseif value.quality == 2 then
			if value.level < 100 then
				GameTooltip:AddDoubleLine("|cff1eff00[" .. value.level .. "] |r" .. "|cffffffff" .. value.name .. "|r", status);
			else
				GameTooltip:AddDoubleLine("|cff1eff00[" .. value.iLevel .. "] |r" .. "|cffffffff" .. value.name .. "|r", status);
			end
		end
	end
end

function follower_sorting(a, b)

	if a.iLevel > b.iLevel then
		return true		
	elseif a.iLevel == b.iLevel then
		if a.level > b.level then
			return true
		elseif a.level == b.level then
			if a.quality > b.quality then
				return true
			elseif a.quality == b.quality then
				if a.name < b.name then
					return true
				else 
					return false
				end
			end
		end
		return false
	end
end 